#ifndef id6FB3FC97331449038D42AAAB4C01ABA1
#define id6FB3FC97331449038D42AAAB4C01ABA1

#include "doorkeeper/components/layer.hpp"
#include "doorkeeper/components/exception.hpp"
#include <vector>
#include <ciso646>
#include <memory>
#include <cstdint>

namespace dk {
	template <uint32_t D>
	class BaseMapSource;

	template <uint32_t D>
	class Tyler {
		typedef std::unique_ptr<LayerBase<D>> LayerPtr;
		typedef std::vector<LayerPtr> LayerList;
	public:
		typedef typename LayerBase<D>::coords coords;

		Tyler ( void ) = delete;
		Tyler ( Tyler&& ) = default;
		explicit Tyler ( const coords& parTileSize );
		~Tyler ( void ) noexcept = default;

		typename coords::scalar_type tiles_count ( void ) const;
		const coords& map_size ( void ) const { return m_size; }

		template <typename T>
		Layer<T, D>& push_layer ( BaseMapSource<D>* parTilemap, int parIndex );
		template <typename T>
		Layer<T, D>& push_layer ( BaseMapSource<D>* parTilemap, const coords& parSubdiv, int parIndex );
		template <typename T>
		void push_layer_void ( BaseMapSource<D>* parTilemap, int parIndex );

		void preload ( const coords& parFrom, const coords& parTo );

	private:
		coords m_size;
		const coords m_tilesize;
		LayerList m_layers;
	};
} //namespace dk

#include "doorkeeper/implem/tyler.inl"

#endif
